		.MODEL	Tiny,C
		LOCALS	@@
		JUMPS

TextBufSize	EQU	2000
MarkColor	EQU	50h

ErrSyntax	EQU	1
ErrLoaded	EQU	2
ErrNoMouse	EQU	3
ErrOldDrv	EQU	4
ErrNotLoaded	EQU	5
ErrUninst	EQU	6

TextBuffer	EQU	Init0

; Far address structure definition.
FARADDR		STRUC
  Offs		DW	?		; Offset
  Segm		DW	?		; Segment
FARADDR		ENDS

		.CODE
		.STARTUP
		JMP	Init0

Vect16		DD	0
Vect1C		DD	0
Vect21		DD	0
Vect28		DD	0
Vect29		DD	0
MouseVisible	DB	0
NoHotKeyFlag	DB	0
PasteModeFlag	DB	0
RelButtonsFlag	DB	0
FullScrFlag	DB	0
Int28flag	DW	0
DosOutputFlag	DW	0
KbdHookFlag	DB	0
KbdCount	DB	0
DblClickFlag	DB	0
DblClickTime	DB	0
VidLines	DB	0
VidColumns	DB	0
StateBufSize	DW	0
MousePosX	DW	0
MousePosY	DW	0
MarkBeg		DW	0
MarkEnd		DW	0
BufferBeg	DW	0
BufferEnd	DW	0

;---------------------------------------------------------------
;	INT 16h handler
;---------------------------------------------------------------
New16		PROC	FAR
		PUSHF
		CMP	AH,1
		JNE	@@Functions
		CMP	CX,0CECEh
		JNE	@@Functions
		MOV	CX,CS
		MOV	BX,0ECECh

  @@Functions:	CMP	AH,10h
		JE	@@Func0
		CMP	AH,11h
		JE	@@Func1
		CMP	AH,1
		JE	@@Func1
		JA	@@OldInt

  @@Func0:	CMP	CS:KbdHookFlag,0
		JNE	@@Func0a
  @@WaitChar:	PUSH	AX
		INC	AH
		PUSHF
		CALL	CS:Vect16
		POP	AX
		JNZ	@@OldInt
		PUSH	CS:Int28flag
		STI
		INT	28h
		POP	CS:Int28flag
		CMP	CS:PasteModeFlag,0
		JE	@@WaitChar
		MOV	CS:PasteModeFlag,0
		MOV	CS:KbdHookFlag,1
  @@Func0a:	POPF
		PUSH	BX
		MOV	CS:KbdCount,3
		MOV	BX,CS:BufferBeg
		MOV	AL,CS:[BX]
		MOV	AH,0
		CMP	AL,13
		JNE	@@CmpEnd
		MOV	AH,1Ch
		INC	BX
  @@CmpEnd:	INC	BX
		MOV	CS:BufferBeg,BX
		CMP	BX,CS:BufferEnd
		POP	BX
		JB	@@Exit
		MOV	CS:KbdHookFlag,0
  @@Exit:	IRET

  @@Func1:	POPF
		CMP	CS:KbdHookFlag,0
		JNE	@@Func1a
		PUSHF
		CALL	CS:Vect16
		JNZ	@@ExitFlags
		PUSH	AX
		MOV	AX,CS:Int28flag
		CMP	CS:DosOutputFlag,0
		JNE	@@ChkPaste
		INC	AX
		CMP	AX,5
		JBE	@@ChkPaste
		DEC	AX
		STI
		INT	28h
  @@ChkPaste:	MOV	CS:Int28flag,AX
		POP	AX
		CMP	CS:PasteModeFlag,0
		JE	@@ExitFlags
		MOV	CS:PasteModeFlag,0
		MOV	CS:KbdHookFlag,1
		MOV	CS:KbdCount,3
  @@Func1a:	CMP	CS:KbdCount,1
		JB	@@SetStatus
		DEC	CS:KbdCount
		CMP	AL,AL
		JMP	@@ExitFlags
  @@SetStatus:	PUSH	BX
		MOV	BX,CS:BufferBeg
		MOV	AL,CS:[BX]
		MOV	AH,0
		POP	BX
  @@ExitFlags:	RET	2

  @@OldInt:	POPF
		JMP	CS:Vect16
New16		ENDP

;---------------------------------------------------------------
;	INT 1Ch handler
;---------------------------------------------------------------
New1C		PROC	FAR
		PUSHF
		CMP	CS:DblClickTime,0
		JE	@@Exit
		DEC	CS:DblClickTime
  @@Exit:	POPF
		JMP	CS:Vect1C
New1C		ENDP

;---------------------------------------------------------------
;	INT 21h handler
;---------------------------------------------------------------
New21		PROC	FAR
		PUSH	CS:DosOutputFlag
		PUSHF
		MOV	CS:Int28flag,0
		MOV	CS:DosOutputFlag,1
		CMP	AH,2
		JE	@@CallOld
		CMP	AH,6
		JE	@@CallOld
		CMP	AH,9
		JE	@@CallOld
		CMP	AX,0C06h
		JE	@@CallOld
		CMP	AH,0Ah
		JE	@@InpStr
		CMP	AX,0C0Ah
		JNE	@@OldInt
  @@InpStr:	MOV	CS:DosOutputFlag,0
		CALL	SaveMouseState
		JC	@@CallOld
		INC	CS:NoHotKeyFlag
		POPF
		PUSHF
		CALL	CS:Vect21
		PUSHF
		DEC	CS:NoHotKeyFlag
		CALL	HideCursor
		CALL	UnmarkBlock
		CALL	RestMouseState
		POPF
		JMP	@@Exit
  @@CallOld:	POPF
		PUSHF
		CALL	CS:Vect21
  @@Exit:	POP	CS:DosOutputFlag
		RET	2
  @@OldInt:	POPF
		POP	CS:DosOutputFlag
		JMP	CS:Vect21
New21		ENDP

;---------------------------------------------------------------
;	INT 28h handler
;---------------------------------------------------------------
New28		PROC	FAR
		PUSHF
		STI
		MOV	CS:Int28flag,0
		CMP	CS:PasteModeFlag,0
		JNE	@@Exit
		CMP	CS:KbdHookFlag,0
		JNE	@@Exit
		CALL	ChkFullScr
		JC	@@OldInt
		CMP	CS:NoHotKeyFlag,0
		JZ	@@ChkHotKey
		CALL	ProcMouse
		JMP	@@OldInt
  @@ChkHotKey:	CALL	ChkHotKey
		JZ	@@OldInt
		CALL	SaveMouseState
		JC	@@OldInt
		CALL	ProcMouse
		CALL	HideCursor
		CALL	UnmarkBlock
		CALL	RestMouseState
  @@OldInt:	POPF
		JMP	CS:Vect28
  @@Exit:	POPF
		IRET
New28		ENDP

;---------------------------------------------------------------
;	INT 29h handler
;---------------------------------------------------------------
New29		PROC	FAR
		PUSHF
		CALL	HideCursor
		CALL	UnmarkBlock
		POPF
		JMP	CS:Vect29
New29		ENDP

;---------------------------------------------------------------
;	Process mouse cut and paste
;---------------------------------------------------------------
ProcMouse	PROC	NEAR
		USES	AX,BX,CX,DX,DS
		PUSH	CS
		POP	DS

  @@ChkHotKey:	CMP	CS:NoHotKeyFlag,0
		JNE	@@GetMouse
		CALL	ChkHotKey
		JZ	@@Exit
  @@GetMouse:	CALL	GetMouse
		TEST	BX,1
		JNZ	@@LeftPress
		TEST	BX,2
		JNZ	@@RightPress
		MOV	DS:RelButtonsFlag,1
		MOV	AH,1
		PUSHF
		CALL	CS:Vect16
		JNZ	@@Exit
  @@Continue:	CMP	DS:NoHotKeyFlag,0
		JNE	@@Exit
		PUSHF
		CALL	CS:Vect28
		JMP	@@ChkHotKey

  @@LeftPress:	CALL	UnmarkBlock		; Left button pressed
		MOV	CS:MarkBeg,AX
		MOV	CS:MarkEnd,AX
		MOV	BL,10
		XCHG	BL,CS:DblClickTime
		CMP	BL,0
		JNE	@@DblClick
  @@Mark:	MOV	CS:DblClickFlag,0
		CALL	MarkBlock
		PUSHF
		CALL	CS:Vect28
		CALL	GetMouse
		TEST	BX,1
		JNZ	@@Mark
		CALL	CopyToBuf
		CALL	CopyWinClip
		JMP	@@ChkHotKey

  @@DblClick:	INC	CS:DblClickFlag		; Double click
		CMP	CS:DblClickFlag,2
		JA	@@Mark
		JE	@@MarkLine
		CALL	MarkWord
		JMP	@@MarkBlock
  @@MarkLine:	DIV	CS:VidColumns
		MUL	CS:VidColumns
		MOV	CS:MarkBeg,AX
		MOV	CS:MarkEnd,AX
		ADD	AL,CS:VidColumns
		ADC	AH,0
  @@MarkBlock:	CALL	MarkBlock
		CALL	CopyToBuf
		CALL	CopyWinClip
  @@LeftRel:	PUSHF
		CALL	CS:Vect28
		CALL	GetMouse
		TEST	BX,1
		JNZ	@@LeftRel
		JMP	@@ChkHotKey

  @@RightPress:	CMP	DS:RelButtonsFlag,0	; Right button pressed
		JE	@@Continue
		MOV	DS:RelButtonsFlag,0
		CALL	PasteWinClip
		CMP	DS:BufferEnd,OFFSET TextBuffer
		JBE	@@RightRel
		MOV	DS:PasteModeFlag,1
		MOV	DS:KbdHookFlag,0
		MOV	DS:BufferBeg,OFFSET TextBuffer
  @@RightRel:	PUSHF
		CALL	CS:Vect28
		CALL	GetMouse
		TEST	BX,2
		JNZ	@@RightRel
  @@Exit:	RET
ProcMouse	ENDP

;---------------------------------------------------------------
;	Check hot key
;	Return:	   ZR - pressed
;---------------------------------------------------------------
ChkHotKey	PROC	NEAR
		USES	AX
		MOV	AH,2
		INT	16h
		TEST	AL,3
		RET
ChkHotKey	ENDP

;---------------------------------------------------------------
;	Save state and show mouse cursor
;	Return:	   NC - ok
;		   CY - error
;---------------------------------------------------------------
SaveMouseState	PROC	NEAR
		USES	AX,BX,CX,DX,DS,ES
		CALL	ChkVideoMode
		JC	@@Exit
		MOV	AX,15h
		INT	33h
		CMP	CS:StateBufSize,BX
		JB	@@Exit
		MOV	AX,2
		INT	33h
		PUSH	CS
		POP	ES
		MOV	DX,OFFSET TextBuffer + TextBufSize
		MOV	AX,16h
		INT	33h
		MOV	AX,3
		INT	33h
		MOV	CS:MousePosX,CX
		MOV	CS:MousePosY,DX
		PUSH	CX
		PUSH	DX
		XOR	CX,CX
		MOV	AX,14h
		INT	33h
		PUSH	CX
		PUSH	DX
		PUSH	ES
		MOV	AX,3533h
		INT	21h
		PUSH	BX
		PUSH	ES
		MOV	AX,21h
		INT	33h
		INC	AX
		JE	@@RestVect
		XOR	AX,AX
		INT	33h
  @@RestVect:	POP	DS
		POP	DX
		MOV	AX,2533h
		INT	21h
		MOV	DL,CS:VidLines
		MOV	DH,0
		MOV	CL,3
		SHL	DX,CL
		DEC	DX
		XOR	CX,CX
		MOV	AX,8
		INT	33h
		MOV	DL,CS:VidColumns
		MOV	DH,0
		MOV	CL,3
		CMP	DL,40
		JA	@@Columns
		INC	CX
  @@Columns:	SHL	DX,CL
		DEC	DX
		XOR	CX,CX
		MOV	AX,7
		INT	33h
		POP	ES
		POP	DX
		POP	CX
		MOV	AX,0Ch
		INT	33h
		POP	DX
		POP	CX
		MOV	AX,4
		INT	33h
		CLC
  @@Exit:	RET
SaveMouseState	ENDP

;---------------------------------------------------------------
;	Restore mouse driver state and cursor position
;---------------------------------------------------------------
RestMouseState	PROC	NEAR
		USES	AX,BX,CX,DX,ES
		MOV	AX,3
		INT	33h
		PUSH	DX
		MOV	AX,15h
		INT	33h
		PUSH	CS
		POP	ES
		MOV	DX,OFFSET TextBuffer + TextBufSize
		MOV	AX,17h
		INT	33h
		POP	DX
		MOV	AX,4
		INT	33h
		MOV	AX,1
		INT	33h
		RET
RestMouseState	ENDP

;---------------------------------------------------------------
;	Get mouse state
;	Return:	   AX - cursor offset
;		   BX - buttons
;---------------------------------------------------------------
GetMouse	PROC	NEAR
		USES	CX,DX
		MOV	AX,3
		INT	33h
		TEST	BL,1
		JNE	@@ShowCur
		CMP	CX,CS:MousePosX
		JNE	@@ShowCur
		CMP	DX,CS:MousePosY
		JE	@@Convert
  @@ShowCur:	CALL	ShowCursor
  @@Convert:	PUSH	BX
		MOV	BX,CX
		MOV	CL,3
		SHR	DX,CL
		CMP	CS:VidColumns,40
		JA	@@ConvRow
		INC	CX
  @@ConvRow:	SHR	BX,CL
		MOV	AX,DX
		MUL	CS:VidColumns
		ADD	AX,BX
		POP	BX
		RET
GetMouse	ENDP

;---------------------------------------------------------------
;	Show mouse cursor
;---------------------------------------------------------------
ShowCursor	PROC	NEAR
		USES	AX
		CMP	CS:MouseVisible,0
		JNE	@@Exit
		MOV	CS:MouseVisible,1
		MOV	AX,1
		INT	33h
  @@Exit:	RET
ShowCursor	ENDP

;---------------------------------------------------------------
;	Hide mouse cursor
;---------------------------------------------------------------
HideCursor	PROC	NEAR
		USES	AX,BX,CX,DX
		CMP	CS:MouseVisible,0
		JE	@@Exit
		MOV	CS:MouseVisible,0
		MOV	AX,2
		INT	33h
		MOV	AX,3
		INT	33h
		MOV	CS:MousePosX,CX
		MOV	CS:MousePosY,DX
  @@Exit:	RET
HideCursor	ENDP

;---------------------------------------------------------------
;	Check full screen mode
;	Return:	   NC - full screen
;		   CY - windowed
;---------------------------------------------------------------
ChkFullScr	PROC	NEAR
		USES	AX,DX
		CMP	CS:FullScrFlag,0
		JE	@@Exit
		MOV	DX,3D6h
		MOV	AL,82h
		OUT	DX,AL
		IN	AL,DX
		CMP	AL,1
  @@Exit:	RET
ChkFullScr	ENDP

;---------------------------------------------------------------
;	Check video mode
;	Return:	   NC - text mode
;		   CY - graphic mode
;---------------------------------------------------------------
ChkVideoMode	PROC	NEAR
		USES	AX,BX,CX,DX,BP,ES
		MOV	BX,0FF10h
		MOV	AH,12h
		INT	10h
		MOV	DL,25
		CMP	BX,0FF10h
		JE	@@Columns
		MOV	AX,3
		INT	33h
		PUSH	CX
		PUSH	DX
		MOV	BH,2
		MOV	AX,1130h
		INT	10h
		MOV	BX,DX
		POP	DX
		POP	CX
		MOV	AX,4
		INT	33h
		MOV	DX,BX
		INC	DX
  @@Columns:	MOV	AH,0Fh
		INT	10h
		MOV	AL,DL
		MOV	CS:VidLines,AL
		MOV	CS:VidColumns,AH
		MUL	AH
		SHL	AX,1
		SHL	AX,1
		XOR	BX,BX
		MOV	ES,BX
		CMP	AX,ES:[44Ch]
  @@Exit:	RET
ChkVideoMode	ENDP

;---------------------------------------------------------------
;	Display mark block
;		   AX - mouse cursor offset
;---------------------------------------------------------------
MarkBlock	PROC	NEAR
		USES	AX,BX,CX,DX,SI,DI,BP
		SUB	AX,CS:MarkEnd
		JE	@@Exit
		MOV	DI,AX

		MOV	AX,2			; Hide mouse cursor
		INT	33h

		MOV	AH,0Fh			; Hide cursor
		INT	10h
		MOV	AH,3
		INT	10h
		PUSH	DX
		PUSH	CX
		OR	CH,20h
		MOV	AH,1
		INT	10h

		MOV	SI,CS:MarkEnd		; Mark block on the screen
		DEC	SI
		MOV	CX,1
		XOR	DX,DX
		OR	DI,DI
		JNS	@@Next
		NEG	DI
		XCHG	CX,DX
  @@Next:	ADD	SI,CX
		PUSH	DX
		PUSH	CX
		MOV	AX,SI
		DIV	CS:VidColumns
		MOV	DH,AL
		MOV	DL,AH
		MOV	AH,2
		INT	10h
		MOV	AH,8
		INT	10h
		MOV	BL,AH
		XOR	BL,MarkColor
		MOV	CX,1
		MOV	AH,9
		INT	10h
		POP	CX
		POP	DX
		SUB	SI,DX
		DEC	DI
		JNZ	@@Next
		INC	SI
		MOV	CS:MarkEnd,SI

		POP	CX			; Restore cursor
		POP	DX
		MOV	AH,2
		INT	10h
		MOV	AH,1
		INT	10h

		MOV	AX,1			; Show mouse cursor
		INT	33h
  @@Exit:	RET
MarkBlock	ENDP

;---------------------------------------------------------------
;	Unmark block on the screen
;---------------------------------------------------------------
UnmarkBlock	PROC	NEAR
		USES	AX,BX
		MOV	AX,CS:MarkBeg
		XCHG	AX,CS:MarkEnd
		CALL	MarkBlock
		MOV	CS:MarkBeg,AX
		RET
UnmarkBlock	ENDP

;---------------------------------------------------------------
;	Mark word
;	Return:	   AX - mouse cursor offset
;---------------------------------------------------------------
MarkWord	PROC	NEAR
		USES	BX,CX,DX,SI,BP
		MOV	AX,2			; Hide mouse cursor
		INT	33h

		MOV	AH,0Fh			; Hide cursor
		INT	10h
		MOV	AH,3
		INT	10h
		PUSH	DX
		PUSH	CX
		OR	CH,20h
		MOV	AH,1
		INT	10h

		MOV	SI,CS:MarkBeg
		CALL	ChkLetter
		JC	@@Exit
  @@WordBeg:	CALL	ChkLetter
		DEC	SI
		JNC	@@WordBeg
		INC	SI
		INC	SI
		MOV	CS:MarkBeg,SI
		MOV	CS:MarkEnd,SI
  @@WordEnd:	INC	SI
		CALL	ChkLetter
		JNC	@@WordEnd

  @@Exit:	POP	CX			; Restore cursor
		POP	DX
		MOV	AH,2
		INT	10h
		MOV	AH,1
		INT	10h

		MOV	AX,1			; Show mouse cursor
		INT	33h
		MOV	AX,SI
		RET
MarkWord	ENDP

;---------------------------------------------------------------
;	Check letter
;		   SI - pointer to character
;	Return:	   NC - letter
;		   CY - not letter
;---------------------------------------------------------------
ChkLetter	PROC	NEAR
		MOV	AX,SI
		DIV	CS:VidColumns
		MOV	DH,AL
		MOV	DL,AH
		MOV	AH,2
		INT	10h
		MOV	AH,8
		INT	10h
		CMP	AL,'0'
		JB	@@NoLetter
		CMP	AL,'9'
		JBE	@@Exit
		CMP	AL,'A'
		JB	@@NoLetter
		CMP	AL,'Z'
		JBE	@@Exit
		CMP	AL,'_'
		JE	@@Exit
		CMP	AL,'a'
		JB	@@NoLetter
		CMP	AL,'z'
		JBE	@@Exit
		CMP	AL,80h
		JB	@@NoLetter
		CMP	AL,0B0h
		JB	@@Exit
		CMP	AL,0E0h
		JAE	@@Exit
  @@NoLetter:	STC
		RET
  @@Exit:	CLC
		RET
ChkLetter	ENDP

;---------------------------------------------------------------
;	Copy marked block to buffer
;---------------------------------------------------------------
CopyToBuf	PROC	NEAR
		USES	AX,BX,CX,DX,SI,DI,BP,ES
		MOV	AX,2			; Hide mouse cursor
		INT	33h

		MOV	AH,0Fh			; Hide cursor
		INT	10h
		MOV	AH,3
		INT	10h
		PUSH	DX
		PUSH	CX
		OR	CH,20h
		MOV	AH,1
		INT	10h

		CLD
		PUSH	CS
		POP	ES
		MOV	DI,OFFSET TextBuffer
		MOV	SI,CS:MarkBeg
		MOV	CX,CS:MarkEnd
		CMP	SI,CX
		JZ	@@BufEnd
		JB	@@ChkEndBuf
		XCHG	SI,CX
  @@ChkEndBuf:	CMP	DI,OFFSET TextBuffer + TextBufSize-1
		JAE	@@BufEnd
		MOV	AX,SI
		DIV	CS:VidColumns
		MOV	DH,AL
		MOV	DL,AH
		MOV	AH,2
		INT	10h
		MOV	AH,8
		INT	10h
		CMP	AL,' '
		JAE	@@PutChar
		MOV	AL,' '
  @@PutChar:	STOSB
		INC	SI
		INC	DX			; Check EOF
		CMP	DL,CS:VidColumns
		JNZ	@@Next
  @@ChkSpace:	DEC	DI
		CMP	BYTE PTR ES:[DI],' '
		JE	@@ChkSpace
		INC	DI
		CMP	DI,OFFSET TextBuffer + TextBufSize-2
		JAE	@@BufEnd
		MOV	AX,0A0Dh
		STOSW
  @@Next:	CMP	SI,CX
		JNE	@@ChkEndBuf
  @@BufEnd:	MOV	CS:BufferBeg,0FFFFh
		MOV	CS:BufferEnd,DI
		MOV	AL,0
		STOSB

		POP	CX			; Restore cursor
		POP	DX
		MOV	AH,2
		INT	10h
		MOV	AH,1
		INT	10h

		MOV	AX,1			; Show mouse cursor
		INT	33h
		RET
CopyToBuf	ENDP

;---------------------------------------------------------------
;	Copy internal buffer to Windows clipboard
;---------------------------------------------------------------
CopyWinClip	PROC	NEAR
		USES	AX,BX,CX,DX,SI,ES
		MOV	AX,1701h
		INT	2Fh
		OR	AX,AX
		JE	@@Exit
		MOV	AX,1702h
		INT	2Fh
		OR	AX,AX
		JE	@@Close
		PUSH	CS
		POP	ES
		MOV	BX,OFFSET TextBuffer
		MOV	CX,CS:BufferEnd
		SUB	CX,BX
		XOR	SI,SI
		TEST	CX,1Fh
		JNZ	@@Copy
		INC	CX
  @@Copy:	MOV	DX,7
		MOV	AX,1703h
		INT	2Fh
  @@Close:	MOV	AX,1708h
		INT	2Fh
  @@Exit:	RET
CopyWinClip	ENDP

;---------------------------------------------------------------
;	Copy Windows clipboard to internal buffer
;---------------------------------------------------------------
PasteWinClip	PROC	NEAR
		USES	AX,BX,CX,DX,SI,ES
		MOV	CS:BufferBeg,0FFFFh
		MOV	AX,1701h
		INT	2Fh
		OR	AX,AX
		JE	@@Exit
		MOV	DX,7
		MOV	AX,1704h
		INT	2Fh
		OR	AX,AX
		JE	@@Close
		OR	DX,DX
		JNE	@@Close
		CMP	AX,TextBufSize
		JA	@@Close
		PUSH	AX
		PUSH	CS
		POP	ES
		MOV	BX,OFFSET TextBuffer
		MOV	DX,7
		MOV	AX,1705h
		INT	2Fh
		POP	DX
		OR	AX,AX
		JE	@@Close
		ADD	DX,OFFSET TextBuffer
		MOV	CS:BufferEnd,DX
  @@Close:	MOV	AX,1708h
		INT	2Fh
  @@Exit:	RET
PasteWinClip	ENDP

;---------------------------------------------------------------
;	Text strings
;---------------------------------------------------------------
		.CONST
Title_S		DB	      'Mouse cut and paste driver. Version 1.0'
		DB	13,10,'Copyright (C) 1999 Vsevolod Volkov'
		DB	13,10,'$'
Syntax_S	DB	13,10,'Usage:   GPM [option]'
		DB	13,10
		DB	13,10,'Options: /O - disable in windowed OS/2 DOS box'
		DB	13,10,'         /U - uninstall'
		DB	13,10
		DB	13,10,'Use the left button to select a part of the screen.'
		DB	13,10,'Double click left button to select a word.'
		DB	13,10,'Triple click left button to select whole line.'
		DB	13,10,'Paste the selected text by clicking the right button.'
		DB	13,10,'Hold down Shift to avoid conflicts with other programs.'
		DB	13,10,'$'
Loaded_S	DB	13,10,'GPM is already installed.'
		DB	13,10,'$'
NoMouse_S	DB	13,10,'No mouse driver found.'
		DB	13,10,'$'
OldDriver_S	DB	13,10,'Mouse driver is too old.'
		DB	13,10,'$'
Uninstall_S	DB	13,10,'GPM is uninstalled.'
		DB	13,10,'$'
NotLoaded_S	DB	13,10,'GPM is not installed yet.'
		DB	13,10,'$'
NoUninst_S	DB	13,10,'Could not uninstall GPM.'
		DB	13,10,'$'

;---------------------------------------------------------------
;	Init program
;---------------------------------------------------------------
		.CODE
Init0:		MOV	DX,OFFSET Title_S	; Print title
		MOV	AH,9
		INT	21h

		MOV	CX,0CECEh		; Check in memory
		MOV	AX,1CCh
		INT	16h
		CMP	BX,0ECECh
		MOV	BL,0
		JNE	CmdLine0
		INC	BX

CmdLine0:	MOV	SI,81h			; Parse command line
		MOV	DX,OFFSET Syntax_S
		MOV	BH,ErrSyntax
CmdLine1:	LODSB
		CMP	AL,' '
		JE	CmdLine1
		CMP	AL,9
		JE	CmdLine1
		CMP	AL,13
		JZ	Install
		CMP	AL,'/'
		JE	CmdLine2
		CMP	AL,'-'
		JNE	Error
CmdLine2:	LODSB
		CMP	AL,'a'
		JB	CmdLine3
		CMP	AL,'z'
		JA	CmdLine3
		SUB	AL,20h
CmdLine3:	CMP	AL,'O'
		JNE	Uninstall
		MOV	DS:FullScrFlag,1
		JMP	CmdLine1

Uninstall:	CMP	AL,'U'
		JNE	Error

		MOV	DX,OFFSET NotLoaded_S	; Uninstall
		MOV	BH,ErrNotLoaded
		OR	BL,BL
		JE	Error

		MOV	ES,CX			; Check vectors
		MOV	AX,3516h
		INT	21h
		MOV	AX,ES
		CMP	AX,CX
		JNE	NoUninst
		MOV	ES,CX
		MOV	AX,351Ch
		INT	21h
		MOV	AX,ES
		CMP	AX,CX
		JNE	NoUninst
		MOV	ES,CX
		MOV	AX,3521h
		INT	21h
		MOV	AX,ES
		CMP	AX,CX
		JNE	NoUninst
		MOV	ES,CX
		MOV	AX,3528h
		INT	21h
		MOV	AX,ES
		CMP	AX,CX
		JNE	NoUninst
		MOV	ES,CX
		MOV	AX,3529h
		INT	21h
		MOV	AX,ES
		CMP	AX,CX
		JNE	NoUninst

		MOV	ES,CX			; Restore vectors
		LDS	DX,ES:Vect16
		MOV	AX,2516h
		INT	21h
		LDS	DX,ES:Vect1C
		MOV	AX,251Ch
		INT	21h
		LDS	DX,ES:Vect21
		MOV	AX,2521h
		INT	21h
		LDS	DX,ES:Vect28
		MOV	AX,2528h
		INT	21h
		LDS	DX,ES:Vect29
		MOV	AX,2529h
		INT	21h

		MOV	AH,49h			; Release memory
		INT	21h
		MOV	ES,ES:[2Ch]
		MOV	AH,49h
		INT	21h

		PUSH	CS			; Uninstall message
		POP	DS
		MOV	DX,OFFSET Uninstall_S
		MOV	BH,0
		JMP	Error

NoUninst:	MOV	DX,OFFSET NoUninst_S	; Can't uninstall
		MOV	BH,ErrUninst
		JMP	Error

Install:	MOV	DX,OFFSET Loaded_S	; Already installed
		MOV	BH,ErrLoaded
		OR	BL,BL
		JNE	Error

		MOV	AX,21h			; Init mouse
		INT	33h
		INC	AX
		JE	StateBuffer
		XOR	AX,AX
		INT	33h
		MOV	DX,OFFSET NoMouse_S
		MOV	BH,ErrNoMouse
		INC	AX
		JNZ	Error

StateBuffer:	XOR	BX,BX			; Get size of state buffer
		MOV	AX,15h
		INT	33h
		OR	BX,BX
		JNE	SaveSize
		MOV	DX,OFFSET OldDriver_S
		MOV	BH,ErrOldDrv
		JMP	Error
SaveSize:	MOV	StateBufSize,BX

		MOV	AX,351Ch		; Hook vectors
		INT	21h
		MOV	Vect1C.Offs,BX
		MOV	Vect1C.Segm,ES
		MOV	DX,OFFSET New1C
		MOV	AH,25h
		INT	21h
		MOV	AX,3521h
		INT	21h
		MOV	Vect21.Offs,BX
		MOV	Vect21.Segm,ES
		MOV	DX,OFFSET New21
		MOV	AH,25h
		INT	21h
		MOV	AX,3528h
		INT	21h
		MOV	Vect28.Offs,BX
		MOV	Vect28.Segm,ES
		MOV	DX,OFFSET New28
		MOV	AH,25h
		INT	21h
		MOV	AX,3529h
		INT	21h
		MOV	Vect29.Offs,BX
		MOV	Vect29.Segm,ES
		MOV	DX,OFFSET New29
		MOV	AH,25h
		INT	21h
		MOV	AX,3516h
		INT	21h
		MOV	Vect16.Offs,BX
		MOV	Vect16.Segm,ES
		MOV	DX,OFFSET New16
		MOV	AH,25h
		INT	21h

		MOV	DX,StateBufSize		; Stay resident
		ADD	DX,OFFSET TextBuffer + TextBufSize
		INT	27h

Error:		PUSH	AX			; Print message and exit
		MOV	AH,9
		INT	21h
		POP	AX
		MOV	AH,4Ch
		INT	21h

		END
